/*
 * COPYRIGHT AND PERMISSION NOTICE
 * 
 * Copyright (c) 2003 Embedded Unit Project
 * 
 * All rights reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining 
 * a copy of this software and associated documentation files (the 
 * "Software"), to deal in the Software without restriction, including 
 * without limitation the rights to use, copy, modify, merge, publish, 
 * distribute, and/or sell copies of the Software, and to permit persons 
 * to whom the Software is furnished to do so, provided that the above 
 * copyright notice(s) and this permission notice appear in all copies 
 * of the Software and that both the above copyright notice(s) and this 
 * permission notice appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT 
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR 
 * HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY 
 * SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright holder 
 * shall not be used in advertising or otherwise to promote the sale, 
 * use or other dealings in this Software without prior written 
 * authorization of the copyright holder.
 *
 * $Id: Test.h,v 1.2 2003/09/05 11:28:55 arms22 Exp $
 */
#ifndef	__TEST_H__
#define	__TEST_H__

typedef struct __TestResult		TestResult;
typedef struct __TestResult*	TestResultRef;

typedef struct __TestImplement	TestImplement;
typedef struct __TestImplement*	TestImplementRef;

typedef unsigned long TestTypeID;
typedef char*(*TestNameFunction)(void*);
typedef void(*TestRunFunction)(void*,TestResultRef);
typedef int(*TestCountTestCasesFunction)(void*);

struct __TestImplement {
	TestTypeID type;
	TestNameFunction name;
	TestRunFunction run;
	TestCountTestCasesFunction countTestCases;
};

typedef struct __Test	Test;
typedef struct __Test*	TestRef;

struct __Test {
	TestImplementRef isa;
};

#define MakeTestTypeID(a,b,c,d)	(TestTypeID)((a<<24)|(b<<16)|(c<<8)|(d<<0))

#define Test_type(t)			(t)->isa->type
#define Test_name(t)			(t)->isa->name(t)
#define Test_run(t,r)			(t)->isa->run(t,r)
#define Test_countTestCases(t)	(t)->isa->countTestCases(t)

#endif/*__TEST_H__*/
